Subject: bug#32234: [PATCH 2/2] database: Serialize all database accesses in a thread.

From: [email-masked] (Ludovic Courtès)
Date: Sun, 19 Aug 2018 16:06:03 +0200

Hi Clément!

Clément Lassieur <[email-masked]> skribis:

> Fixes <https://bugs.gnu.org/32234>.
>
> * bin/cuirass.in (main): Keep only one WITH-DATABASE call around all fibers.
> Remove all DB arguments.
> * src/cuirass/base.scm (evaluate, update-build-statuses!, spawn-builds,
> handle-build-event, build-packages): Remove all DB arguments.
> (clear-build-queue, cancel-old-builds): Wrap in WITH-DB-CRITICAL-SECTION,
> remove all DB arguments.
> (restart-builds): Remove the NON-BLOCKING call, remove all DB arguments.
> (process-specs): Remove all DB arguments, remove the WITH-DATABASE call.
> * src/cuirass/database.scm (%db-channel): New parameter.
> (with-db-critical-section): New macro.
> (db-add-input, db-add-specification, db-get-inputs, db-get-specifications,
> db-add-evaluation, db-add-build, db-update-build-status!, db-get-outputs,
> db-get-builds, db-get-build, db-get-pending-derivations, db-get-stamp,
> db-add-stamp, db-get-evaluations, db-get-evaluations-build-summary,
> db-get-evaluations-id-min, db-get-evaluations-id-max, db-get-builds-min,
> db-get-builds-max): Wrap in WITH-DB-CRITICAL-SECTION, remove all DB arguments.
> (with-database): Wrap BODY in PARAMETERIZE form that sets %DB-CHANNEL to the
> channel returned by MAKE-CRITICAL-SECTION.
> * src/cuirass/http.scm (handle-build-request, handle-builds-request): Remove
> all DB arguments.
> (url-handler): Remove all DB arguments, remove the DB-CHANNEL state, remove
> the WITH-CRITICAL-SECTION calls.
> (run-cuirass-server): Remove the DB arguments, remove the
> MAKE-CRITICAL-SECTION call.
> * src/cuirass/utils.scm (make-critical-section): Replace SPAWN-FIBER with
> CALL-WITH-NEW-THREAD.  Wrap body in PARAMETERIZE form that clears
> CURRENT-FIBER.
> * tests/database.scm (with-temporary-database, db-add-specification,
> db-add-build, db-update-build-status!, db-get-builds,
> db-get-pending-derivations): Remove the DB arguments.
> (db-init): Set the %DB-CHANNEL parameter to the channel returned by
> MAKE-CRITICAL-SECTION, and return #t.
> (database): Set %DB-CHANNEL to #f during cleanup.
> * tests/http.scm (db-init): Set the %DB-CHANNEL parameter to the channel
> returned by MAKE-CRITICAL-SECTION, and return #t.
> (cuirass-run, fill-db): Remove the DB arguments.
> (http): Set %DB-CHANNEL to #f during cleanup.

Excellent, thanks for working on this!  This looks great to me, and I
think the pros outweigh the cons.  Did you check on a big database how
well it performs?

One comment:

> -(define* (handle-build-event db event)
> +(define* (handle-build-event event)
>    "Handle EVENT, a build event sexp as produced by 'build-event-output-port',
> -updating DB accordingly."
> +updating the database accordingly."

[...]

> +(define %db-channel
> +  (make-parameter #f))
> +
> +(define-syntax-rule (with-db-critical-section db exp ...)
> +  "Evaluate EXP... in the critical section corresponding to %DB-CHANNEL.
> +DB is bound to the argument of that critical section: the database
> +connection."
> +  (call-with-critical-section (%db-channel)
> +                              (lambda (db) exp ...)))
> +

I think I find it nicer to keep the ‘db’ parameter everywhere (except
that it’s now a channel instead of an actual database) rather than using
this global variable.

WDYT?

Really happy we have a solution to this problem!

Thank you,
Ludo’.